import time
import calendar

from report import report_sxw

SO_STATE = ['progress','done','manual','shipping_except','invoice_except']
I_STATE = ['paid']

class mm_report(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context=None):
        super(mm_report, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time':time,
            'get_brands':self._get_brands,
            'format_num':self._format_num,
            })
    def _format_num(self, num, digits=2):
        if int(num) == num:
            return int(num)
        if round(num,1) == round(num,2):
            return self.formatLang(num,1)
        else:
            return self.formatLang(num,digits) 

    def _get_inv_total(self, year_start, year_stop, product_id, brand, purpose):
        so_obj = self.pool.get('sale.order')
        po_obj = self.pool.get('purchase.order')
        sol_obj = self.pool.get('sale.order.line')
        pol_obj = self.pool.get('purchase.order.line')
        inv_obj = self.pool.get('account.invoice')
        invl_obj = self.pool.get('account.invoice.line')

        result = {
                'c_inv_total':0.0,
                's_inv_total':0.0,
                }
        i_so_ids = so_obj.search(self.cr, self.uid, [('brand','=',brand),('date_order','<=',year_stop),('date_order','>=',year_stop),('purpose','=',purpose)])
        #print 'soid--->>>',so_ids
        for so in so_obj.browse(self.cr, self.uid, i_so_ids):
            so_inv_ids = inv_obj.search(self.cr,self.uid,[('origin','ilike',so.name),('state','in',['paid'])])
            so_invl_ids = invl_obj.search(self.cr, self.uid, [('product_id','=',product_id),('invoice_id','in',so_inv_ids)])
            #print 'so_invl:%s,product_id:%s,so:%s'%(so_invl_ids,product_id,so.name)
            for so_invl in invl_obj.browse(self.cr, self.uid, so_invl_ids):
                #print 'so_invl--->>',so_invl
                result['c_inv_total'] += so_invl.price_subtotal or 0.0
            #Find the PO invoice
            po_ids = po_obj.search(self.cr, self.uid,[('origin','ilike',so.name)])
            #print 'po_ids:',po_ids
            if po_ids:
                po = po_obj.browse(self.cr, self.uid, po_ids)
                #print 'po:',po
                po_inv_ids = inv_obj.search(self.cr,self.uid,[('origin','ilike',po[0].name),('state','in',['paid'])])
                #print 'po_inv-->>>',po_inv_ids
                po_invl_ids = invl_obj.search(self.cr, self.uid, [('product_id','=',product_id),('invoice_id','in',po_inv_ids)])
                #print 'po_invl--->',po_invl_ids
                for po_invl in invl_obj.browse(self.cr, self.uid, po_invl_ids):
                    #print 'invl--->>',po_invl
                    result['s_inv_total'] += po_invl.price_subtotal or 0.0
        #print 'result--->>>',result
        return result
            
     
    def _get_month_line(self, year, product_id, month, brand, purpose):
        item = 0
        sqm = 0
        usd = 0
        s_sqm = 0
        s_usd = 0
        so_obj = self.pool.get('sale.order')
        sol_obj = self.pool.get('sale.order.line')
        sm_obj = self.pool.get('stock.move')
        m_so_ids = so_obj.search(self.cr, self.uid,[('date_order','<=',str(year)+'-'+str(month)+'-'+str(calendar.monthrange(int(year),month)[1])),('date_order','>=',str(year)+'-'+str(month)+'-1'),('brand','=',brand),('purpose','=',purpose),('state','in',SO_STATE)])
        #print 'm_so_ids:',m_so_ids
        #print 'product_ids',product_id
        for m_so in so_obj.browse(self.cr, self.uid, m_so_ids):
            for m_sol in m_so.order_line:
                if m_sol.product_id.id == product_id:
                    item += 1
                    sqm  += m_sol.product_uom_qty
                    usd  += m_sol.price_subtotal
        result = {
                'item':item,
                'sqm':sqm,
                'usd':usd,
                }
        sm_ids = sm_obj.search(self.cr, self.uid, [('date','>=',str(year)+'-'+str(month)+'-1'),('date','<=',str(year)+'-'+str(month)+'-'+str(calendar.monthrange(int(year),month)[1])),('state','=','done'),('sale_line_id','!=',None)])
       # print '2sm_ids:',sm_ids
        for sm in sm_obj.browse(self.cr, self.uid, sm_ids):
        #    print 'brand1:%s brand2:%s'%(brand,sm.sale_line_id.order_id.brand)
            if sm.product_id.id == product_id  and ((brand and sm.sale_line_id.order_id.brand == brand) or (brand == None and not sm.sale_line_id.order_id.brand)) and sm.sale_line_id.order_id.purpose == purpose:
               
        #      print 'brand:%s in:%i'%(sm.sale_line_id.order_id.brand,sm.product_id)
               s_sqm += sm.product_qty
               s_usd += sm.sale_line_id.price_unit * (1 - (sm.sale_line_id.discount or 0.0) / 100.0) * sm.product_qty
        ship_res = self.cr.fetchall()
        #print 'ship_res',ship_res
        result['s_sqm'] = s_sqm
        result['s_usd'] = s_usd
        #print 'result:',result
        return result

    def _get_brands(self,data):
        cat_ids=[]
        res=[]
        pro_ids=[]
        so_obj = self.pool.get('sale.order')
        product_obj = self.pool.get('product.product')
        sm_obj = self.pool.get('stock.move')
        #invl_obj = self.pool.get('account.invoice.line')
        #pol_obj = self.pool.get('purchase.order.line')
        #po_obj = self.pool.get('purchase.order')

        so_ids = so_obj.search(self.cr, self.uid, [])
        #print 'so_ids:',so_ids
        so_orders = so_obj.browse(self.cr, self.uid, so_ids)
        brands  = list(set([so.brand for so in so_orders]))
        #so_name = list(set([so.name for so in so_oders]))
        #po_ids = po_obj.search(self.cr, self.uid,[('origin','in',so_name)])
        #po_names = list(set([po.name for po in po_obj.browse]))
        print 'brands:',brands
        #print 'brands:%s',brands
        if not brands:
            return res
        year_total_month = {}
        year_total_item = 0.0
        year_total_sqm = 0.0
        year_total_usd = 0.0
        year_total_s_sqm = 0.0
        year_total_s_usd = 0.0
        year_total_c_inv = 0.0
        year_total_s_inv = 0.0
        print 'brands:',brands
        for brand in brands:
            print 'brand:',brand
            self.cr.execute('''SELECT DISTINCT sol.product_id \
                               FROM sale_order_line AS sol \
                               LEFT JOIN sale_order AS so on(so.id=sol.order_id) \
                               WHERE so.date_order>='%s' \
                               AND so.date_order<='%s' \
                               AND so.purpose = '%s' \
                               AND so.state in (%s)
                               AND %s '''%(data['year_start'], data['year_stop'], data['purpose'],"'"+"','".join(SO_STATE)+"'", 'so.brand'+(brand and "='"+brand+"'" or ' is null')))
            product_ids = [product_id[0] for product_id in self.cr.fetchall()]
            sm_ids = sm_obj.search(self.cr, self.uid, [('date','>=',data['year_start']),('date','<=',data['year_stop']),('state','=','done'),('sale_line_id','!=',None)])
            #print 'sm_ids:',sm_ids
            for sm in sm_obj.browse(self.cr, self.uid, sm_ids):
               #print 'sm.product_id:%s,  purpose:%s'%(sm.product_id.id,sm.sale_line_id.order_id.purpose)
                if  sm.sale_line_id.order_id.purpose == data['purpose'] and sm.sale_line_id.order_id.brand == brand: 
                #   print 'product_append:',sm.product_id
                    product_ids.append(sm.product_id.id)
           #invl_ids = invl_obj.search(self.cr, self.uid, [('product_id','=',product_id),('invoice_id','in',so_inv_ids),('date_due','<=',data['year_stop']),('date_due','>=',data['year_start']),('state','in',['paid'])])
            #for invl in invl_obj.browse(self.cr, self.uid, invl_ids):
            #    if (so_invl.invoice_id.state in I_STATE) and (invl.origin in so_names or invl.origin in  :
            product_ids = list(set(product_ids))
            print 'product_ids:',product_ids
            if len(product_ids) <= 0:
                continue
            products = []
            cat_total_item = 0
            cat_total_sqm = 0
            cat_total_usd = 0
            cat_total_s_sqm = 0
            cat_total_s_usd = 0
            cat_total_month ={}
            cat_total_c_inv = 0.0
            cat_total_s_inv = 0.0
            for product in product_obj.read(self.cr, self.uid, product_ids, ['name', 'code'], context=self.localcontext):
               # print 'product:',product
                inv_total = self._get_inv_total(data['year_start'], data['year_stop'], product['id'], brand, data['purpose'])
                val = {
                     'id':product['id'],
                     'name':product['name'],
                     'product_total_item':0.0,
                     'product_total_sqm':0.0,
                     'product_total_usd':0.0,
                     'product_total_s_sqm':0.0,
                     'product_total_s_usd':0.0,
                     'c_inv_total':inv_total['c_inv_total'],
                     's_inv_total':inv_total['s_inv_total'],
                 }
                for month in range(1,13):
                    val[month]=self._get_month_line(data['year'], product['id'], month, brand,data['purpose'])
                    val['product_total_item'] += int(val[month].get('item',0))
                    val['product_total_sqm'] += int(val[month].get('sqm',0.0))
                    val['product_total_usd'] += int(val[month].get('usd',0.0))
                    val['product_total_s_sqm'] += int(val[month].get('s_sqm',0.0))
                    val['product_total_s_usd'] += int(val[month].get('s_usd',0.0))
                    if not cat_total_month.get(month,False):
                        cat_total_month.update({month:{'item':0,'sqm':0,'usd':0,'s_sqm':0,'s_usd':0}})
                    cat_total_month[month]['item'] += int(val[month].get('item',0)) 
                    cat_total_month[month]['sqm'] += int(val[month].get('sqm',0.0))
                    cat_total_month[month]['usd'] += int(val[month].get('usd',0.0))
                    cat_total_month[month]['s_sqm'] += int(val[month].get('s_sqm',0.0))
                    cat_total_month[month]['s_usd'] += int(val[month].get('s_usd',0.0))
                    if not year_total_month.get(month,False):
                        year_total_month.update({month:{'item':0,'sqm':0,'usd':0,'s_sqm':0,'s_usd':0}})
                    year_total_month[month]['item'] += int(val[month].get('item',0))
                    year_total_month[month]['sqm'] += int(val[month].get('sqm',0.0))
                    year_total_month[month]['usd'] += int(val[month].get('usd',0.0))
                    year_total_month[month]['s_sqm'] += int(val[month].get('s_sqm',0.0))
                    year_total_month[month]['s_usd'] += int(val[month].get('s_usd',0.0)) 
                    #print 'cat-total:',cat_total_month[month]
                    #print 'year_total_month[month]-->',year_total_month 
                    cat_total_item += int(val[month].get('item',0))
                    cat_total_sqm += int(val[month].get('sqm',0.0))
                    cat_total_usd += int(val[month].get('usd',0.0))
                    cat_total_s_sqm += int(val[month].get('s_sqm',0.0))
                    cat_total_s_usd += int(val[month].get('s_usd',0.0))
                cat_total_c_inv += inv_total['c_inv_total']
                cat_total_s_inv += inv_total['s_inv_total']
                #print 'year_month:',year_total_month
                products.append(val)
            year_total_item += cat_total_item
            year_total_sqm += cat_total_sqm
            year_total_c_inv += cat_total_c_inv
            year_total_s_inv += cat_total_s_inv
            year_total_usd += cat_total_usd
            year_total_s_sqm += cat_total_s_sqm
            year_total_s_usd += cat_total_s_usd
            res.append({
                        'name':brand,
                        'products':products,
                        'cat_total_item':cat_total_item,
                        'cat_total_sqm':cat_total_sqm,
                        'cat_total_usd':cat_total_usd,
                        'cat_total_s_sqm':cat_total_s_sqm,
                        'cat_total_s_usd':cat_total_s_usd,
                        'cat_total_month':cat_total_month,
                        'cat_total_c_inv':cat_total_c_inv,
                        'cat_total_s_inv':cat_total_s_inv,
                    })
        #print 'cat-->',res
        self.localcontext.update({
            'year_total_month':year_total_month,
            'year_total_c_inv':year_total_c_inv,
            'year_total_s_inv':year_total_s_inv,
            'year_total_item':year_total_item,
            'year_total_sqm':year_total_sqm,
            'year_total_usd':year_total_usd,
            'year_total_s_sqm':year_total_s_sqm,
            'year_total_s_usd':year_total_s_usd,
        })
        #print 'res-->',res
        return res


report_sxw.report_sxw('report.sample_mm','sale.order','my-addons/shineit_mm/report/simple_mm.rml',parser=mm_report,header=False)
report_sxw.report_sxw('report.production_mm','sale.order','my-addons/shineit_mm/report/production_mm.rml',parser=mm_report,header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
