import time
import calendar

from report import report_sxw

class mm_report(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context=None):
        super(mm_report, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time':time,
            'get_brands':self._get_brands,
            })

    def _get_inv_total(self, product_id, so_ids, brand):
        so_obj = self.pool.get('sale.order')
        po_obj = self.pool.get('purchase.order')
        sol_obj = self.pool.get('sale.order.line')
        pol_obj = self.pool.get('purchase.order.line')
        inv_obj = self.pool.get('account.invoice')
        invl_obj = self.pool.get('account.invoice.line')

        result = {
                'c_inv_total':0.0,
                's_inv_total':0.0,
                }
        i_so_ids = so_obj.search(self.cr, self.uid, [('id','in',so_ids),('brand','=',brand)])
        #print 'soid--->>>',so_ids
        for so in so_obj.browse(self.cr, self.uid, i_so_ids):
            so_inv_ids = inv_obj.search(self.cr,self.uid,[('origin','ilike',so.name),('state','in',['paid'])])
            so_invl_ids = invl_obj.search(self.cr, self.uid, [('product_id','=',product_id),('invoice_id','in',so_inv_ids)])
            print 'so_invl:%s,product_id:%s,so:%s'%(so_invl_ids,product_id,so.name)
            for so_invl in invl_obj.browse(self.cr, self.uid, so_invl_ids):
                #print 'so_invl--->>',so_invl
                result['c_inv_total'] += so_invl.price_subtotal or 0.0
            #Find the PO invoice
            po_ids = po_obj.search(self.cr, self.uid,[('origin','ilike',so.name)])
            #print 'po_ids:',po_ids
            if po_ids:
                po = po_obj.browse(self.cr, self.uid, po_ids)
                #print 'po:',po
                po_inv_ids = inv_obj.search(self.cr,self.uid,[('origin','ilike',po[0].name),('state','in',['paid','open'])])
                #print 'po_inv-->>>',po_inv_ids
                po_invl_ids = invl_obj.search(self.cr, self.uid, [('product_id','=',product_id),('invoice_id','in',po_inv_ids)])
                #print 'po_invl--->',po_invl_ids
                for po_invl in invl_obj.browse(self.cr, self.uid, po_invl_ids):
                    #print 'invl--->>',po_invl
                    result['s_inv_total'] += po_invl.price_subtotal or 0.0
        print 'result--->>>',result
        return result
            
     
    def _get_month_line(self, year, product_id, month, so_ids, brand):
        item = 0
        sqm = 0
        usd = 0
        s_sqm = 0
        s_usd = 0
        so_obj = self.pool.get('sale.order')
        sol_obj = self.pool.get('sale.order.line')
        sm_obj = self.pool.get('stock.move')
        m_so_ids = so_obj.search(self.cr, self.uid,[('id','in',so_ids),('date_order','<=',str(year)+'-'+str(month)+'-'+str(calendar.monthrange(int(year),month)[1])),('date_order','>=',str(year)+'-'+str(month)+'-1'),('brand','=',brand)])
        #print 'm_so_ids:',m_so_ids
        #print 'product_ids',product_id
        for m_so in so_obj.browse(self.cr, self.uid, m_so_ids):
            for m_sol in m_so.order_line:
                if m_sol.product_id.id == product_id:
                    item += 1
                    sqm  += m_sol.product_uom_qty
                    usd  += m_sol.price_subtotal
        
        result = {
                'item':item,
                'sqm':sqm,
                'usd':usd,
                }
        sm_ids = sm_obj.search(self.cr, self.uid, [('date','>=',str(year)+'-'+str(month)+'-1'),('date','<=',str(year)+'-'+str(month)+'-'+str(calendar.monthrange(int(year),month)[1])),('state','=','done')])
        #print 'sm_ids:',sm_ids
        for sm in sm_obj.browse(self.cr, self.uid, sm_ids):
            print 'brand1:',brand
            print 'brand:',sm.sale_line_id and sm.sale_line_id.order_id.brand
            if sm.product_id.id == product_id and sm.sale_line_id and (sm.sale_line_id.order_id.id in so_ids) and ((brand and sm.sale_line_id.order_id.brand == brand) or (brand == None and not sm.sale_line_id.order_id.brand)):
               if brand == None:
                  print 'NN'
               s_sqm += sm.product_qty
               s_usd += sm.sale_line_id.price_unit * (1 - (sm.sale_line_id.discount or 0.0) / 100.0) * sm.product_qty
        ship_res = self.cr.fetchall()
        #print 'ship_res',ship_res
        result['s_sqm'] = s_sqm
        result['s_usd'] = s_usd
        #print 'result:',result
        return result

    def _get_brands(self,data):
        cat_ids=[]
        res=[]
        pro_ids=[]
        so_obj = self.pool.get('sale.order')
        product_obj = self.pool.get('product.product')
        so_ids = so_obj.search(self.cr, self.uid, [('date_order','>=',data['year_start']),('date_order','<=',data['year_stop']),('state','in',['progress','done','manual','shipping_except','invoice_except','waiting_date']),('purpose','=',data['purpose'])]) 
        print 'so_ids:',so_ids
        if len(so_ids) <= 0:
           return res
        self.cr.execute('''SELECT sol.product_id \
                           FROM sale_order_line AS sol \
                           LEFT JOIN sale_order AS so ON (so.id = sol.order_id) \
                           WHERE so.id in (%s) \
                           GROUP BY(sol.product_id) '''%(','.join(map(str, so_ids))))
        product_ids = [pid[0] for pid in self.cr.fetchall()]
        #print 'prodcut_ids---->>>>',product_ids
        products = product_obj.browse(self.cr, self.uid , list(product_ids)) 
        for product in products:
            pro_ids.append(product.id)
            if product.categ_id.id not in cat_ids:
                cat_ids.append(product.categ_id.id)

       # cats = self.pool.get('product.category').name_get(self.cr, self.uid, cat_ids, context=self.localcontext)
        self.cr.execute('''SELECT DISTINCT brand  \
                           FROM sale_order_line AS sol \
                           LEFT JOIN sale_order AS so ON (so.id = sol.order_id) \
                           WHERE so.id in (%s) \
                           ORDER BY brand'''%(','.join(map(str, so_ids))))
        brands = [brand[0] for brand in self.cr.fetchall()]
       
        #print 'brands:%s',brands
        if not brands:
            return res
        year_total_month = {}
        year_total_item = 0.0
        year_total_sqm = 0.0
        year_total_usd = 0.0
        year_total_s_sqm = 0.0
        year_total_s_usd = 0.0
        year_total_c_inv = 0.0
        year_total_s_inv = 0.0
        for brand in brands:
            print 'brand:',brand
            self.cr.execute('''SELECT DISTINCT sol.product_id \
                               FROM sale_order_line AS sol \
                               LEFT JOIN sale_order AS so on(so.id=sol.order_id) \
                               WHERE so.id in (%s) \
                               AND %s '''%(','.join(map(str,so_ids)), 'so.brand'+(brand and "='"+brand+"'" or ' is null')))
            #product_ids=product_obj.search(self.cr, self.uid, [('id', 'in', pro_ids), ('categ_id', '=', cat[0])], context=self.localcontext)
            product_ids = [product_id[0] for product_id in self.cr.fetchall()]
            products = []
            cat_total_item = 0
            cat_total_sqm = 0
            cat_total_usd = 0
            cat_total_s_sqm = 0
            cat_total_s_usd = 0
            cat_total_month ={}
            cat_total_c_inv = 0.0
            cat_total_s_inv = 0.0
            for product in product_obj.read(self.cr, self.uid, product_ids, ['name', 'code'], context=self.localcontext):
                print 'product:',product
                inv_total = self._get_inv_total(product['id'], so_ids, brand)
                val = {
                     'id':product['id'],
                     'name':product['name'],
                     'product_total_item':0.0,
                     'product_total_sqm':0.0,
                     'product_total_usd':0.0,
                     'product_total_s_sqm':0.0,
                     'product_total_s_usd':0.0,
                     'c_inv_total':inv_total['c_inv_total'],
                     's_inv_total':inv_total['s_inv_total'],
                 }
                for month in range(1,13):
                    val[month]=self._get_month_line(data['year'], product['id'], month, so_ids, brand)
                    val['product_total_item'] += int(val[month].get('item',0))
                    val['product_total_sqm'] += int(val[month].get('sqm',0.0))
                    val['product_total_usd'] += int(val[month].get('usd',0.0))
                    val['product_total_s_sqm'] += int(val[month].get('s_sqm',0.0))
                    val['product_total_s_usd'] += int(val[month].get('s_usd',0.0))
                    if not cat_total_month.get(month,False):
                        cat_total_month.update({month:{'item':0,'sqm':0,'usd':0,'s_sqm':0,'s_usd':0}})
                    cat_total_month[month]['item'] += int(val[month].get('item',0)) 
                    cat_total_month[month]['sqm'] += int(val[month].get('sqm',0.0))
                    cat_total_month[month]['usd'] += int(val[month].get('usd',0.0))
                    cat_total_month[month]['s_sqm'] += int(val[month].get('s_sqm',0.0))
                    cat_total_month[month]['s_usd'] += int(val[month].get('s_usd',0.0))
                    if not year_total_month.get(month,False):
                        year_total_month.update({month:{'item':0,'sqm':0,'usd':0,'s_sqm':0,'s_usd':0}})
                    year_total_month[month]['item'] += int(val[month].get('item',0))
                    year_total_month[month]['sqm'] += int(val[month].get('sqm',0.0))
                    year_total_month[month]['usd'] += int(val[month].get('usd',0.0))
                    year_total_month[month]['s_sqm'] += int(val[month].get('s_sqm',0.0))
                    year_total_month[month]['s_usd'] += int(val[month].get('s_usd',0.0)) 
                    #print 'cat-total:',cat_total_month[month]
                    #print 'year_total_month[month]-->',year_total_month 
                    cat_total_item += int(val[month].get('item',0))
                    cat_total_sqm += int(val[month].get('sqm',0.0))
                    cat_total_usd += int(val[month].get('usd',0.0))
                    cat_total_s_sqm += int(val[month].get('s_sqm',0.0))
                    cat_total_s_usd += int(val[month].get('s_usd',0.0))
                cat_total_c_inv += inv_total['c_inv_total']
                cat_total_s_inv += inv_total['s_inv_total']
                #print 'year_month:',year_total_month
                products.append(val)
            year_total_item += cat_total_item
            year_total_sqm += cat_total_sqm
            year_total_c_inv += cat_total_c_inv
            year_total_s_inv += cat_total_s_inv
            year_total_usd += cat_total_usd
            year_total_s_sqm += cat_total_s_sqm
            year_total_s_usd += cat_total_s_usd
            res.append({
                        'name':brand,
                        'products':products,
                        'cat_total_item':cat_total_item,
                        'cat_total_sqm':cat_total_sqm,
                        'cat_total_usd':cat_total_usd,
                        'cat_total_s_sqm':cat_total_s_sqm,
                        'cat_total_s_usd':cat_total_s_usd,
                        'cat_total_month':cat_total_month,
                        'cat_total_c_inv':cat_total_c_inv,
                        'cat_total_s_inv':cat_total_s_inv,
                    })
        #print 'cat-->',res
        self.localcontext.update({
            'year_total_month':year_total_month,
            'year_total_c_inv':year_total_c_inv,
            'year_total_s_inv':year_total_s_inv,
            'year_total_item':year_total_item,
            'year_total_sqm':year_total_sqm,
            'year_total_usd':year_total_usd,
            'year_total_s_sqm':year_total_s_sqm,
            'year_total_s_usd':year_total_s_usd,
        })
        #print 'res-->',res
        return res


report_sxw.report_sxw('report.sample_mm','sale.order','my-addons/shineit_mm/report/simple_mm.rml',parser=mm_report,header=False)
report_sxw.report_sxw('report.production_mm','sale.order','my-addons/shineit_mm/report/production_mm.rml',parser=mm_report,header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
