# -*- encoding:utf-8 -*-

import time

from report import report_sxw

class po_report(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context=None):
        super(po_report, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time':time,
            'get_po':self._get_po,
            'get_move':self._get_move,
            'format_num':self._format_num,
            })

    def _format_num(self, num, digits=2):
        if int(num) == num:
            return int(num)
        if round(num,1) == round(num,2):
            return self.formatLang(num,1)
        else:
            return self.formatLang(num,digits)
     
    def _get_po(self, so_name=None, product_id=None):
        result = {}
        po_obj = self.pool.get('purchase.order')     
        id = po_obj.search(self.cr, self.uid, [('origin','ilike',so_name)])
        if len(id) > 0:
            po = po_obj.browse(self.cr, self.uid, id[0])
            result ={
                'po_name':po.name,
                'po_date':po.date_order,
                'po_inv':po.invoice_ids[0] or {},
                'note':po.notes,
            }
            if product_id:
                for line in po.order_line:
                    if line.product_id == product_id:
                        result['pol_price'] = line.price_unit
                        result['pol_qty'] = line.product_qty
        return result

    def _get_move(self,move_ids):
        return [move_id for move_id in move_ids if move_id.state=='done']

report_sxw.report_sxw('report.po','sale.order','my-addons/shineit_po/report/po.rml', parser=po_report, header=False)
report_sxw.report_sxw('report.s_po','sale.order','my-addons/shineit_po/report/s_po.rml', parser=po_report, header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
