# -*- coding: utf-8 -*- #

import time 
from osv import osv, fields

PURPOSE_MAPS = {
    'production':'Production',
    'sample':'Sale Sample',
    'development':'Development',
}

class po_report(osv.osv_memory):
    _name = 'po.report'
    _description = 'PO Report'
    _columns = {
        'report_type':fields.selection([('pdf','PDF'),('odt','ODT')],'Report Tyep',required=True),
        'purpose':fields.selection([('production', 'Production'),('sample', 'Sale Sample'),('development','Development')], 'Purpose', required=True),
        'simple_report':fields.boolean('Simple Report?')
    }
    _defaults = {
        'report_type':'pdf',
}
    def print_report(self, cr, uid, ids, context=None):
        '''
        To Print the Po Report
        '''
        if context is None:
            context = {}
        report_obj = self.pool.get('ir.actions.report.xml')
        res = self.read(cr, uid, ids, ['report_type','purpose','simple_report'], context=context)
        so_ids = self.pool.get('sale.order').search(cr, uid, [('purpose','=',res[0]['purpose'])], order='date_order')
        datas = {'ids':so_ids}
        datas['purpose'] = res[0]['purpose']
        datas['purpose_name'] = PURPOSE_MAPS.get(res[0]['purpose'], False)
        #print 'datas:',datas
        report_name = 'po'
        if res[0]['simple_report']:
            report_name = 's_po'
        report_ids = report_obj.search(cr, uid, [('report_name','=',report_name)])
        report_obj.write(cr, uid, report_ids[0], {'report_type':res[0]['report_type']})
        return { 
            'type':'ir.actions.report.xml',
            'report_name':report_name,
            'datas':datas,
        }
po_report()
# vim:expandtab:smartindent:tabstop=4;softtabstop=4;shiftwidth=4;
    
